<?php

namespace SM\Controller;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00052002DescontoMaximoServicoPerfilAcessoService;
use SM\Traits\TResponse;

class Sm00052002DescontoMaximoServicoPerfilAcessoController 
{   
    use TResponse;
    
    protected $descMaximoServicoService;

    public function __construct(Sm00052002DescontoMaximoServicoPerfilAcessoService $descMaximoServicoService) {
        $this->descMaximoServicoService = $descMaximoServicoService;
    }

    public function getNomePerfilAcessoDescontoMaximoServico(Request $request, Response $response){
        try {
            $data = $this->descMaximoServicoService->getNomePerfilAcessoDescontoMaximoServico();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getServicoDescontoMaximoServicoPerfilAcesso(Request $request, Response $response){
        try {
            $data = $this->descMaximoServicoService->getServicoDescontoMaximoServicoPerfilAcesso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveDescMaxServicoPerfilAcesso(DTO\Request $request, DTO\Response $response){
        try {
            $this->descMaximoServicoService->saveDescMaxServicoPerfilAcesso($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function deleteDescMaxServicoModalServicoPerfilAcesso(DTO\Request $request, DTO\Response $response){
        try{
            $this->descMaximoServicoService->deleteDescMaxServicoModalServicoPerfilAcesso($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}