<?php

namespace SM\Service;

use SM\Factory\Sm00057001ConfiguracaoRegionalIdiomaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm00057001ConfiguracaoRegionalIdiomaService
{
    protected $connection;
    protected $Sm00057001ConfiguracaoRegionalIdiomaFactory;
    protected $environment;
    protected $newCode;

    public function __construct(Sm00057001ConfiguracaoRegionalIdiomaFactory $Sm00057001ConfiguracaoRegionalIdiomaFactory, Environment $environment, NewCode $newCode, EntityManager $entityManager)
    {
        $this->Sm00057001ConfiguracaoRegionalIdiomaFactory = $Sm00057001ConfiguracaoRegionalIdiomaFactory;
        $this->environment               = $environment;
        $this->newCode                   = $newCode;
        $this->connection                = $entityManager->getConnection();
    }

    public function getConfiguracaoRegionalIdioma()
    {
        return $this->Sm00057001ConfiguracaoRegionalIdiomaFactory->getConfiguracaoRegionalIdioma();
    }

    public function inserirConfiguracaoRegionalIdioma($parametros)
    {
        $cdoperador = $this->environment->getCdOperador();
        $NRORG = $this->environment->getNrOrg();
        $this->connection->beginTransaction();
        $paramsaux = array(
            "NMIDIOMA" => $parametros[0]['NMIDIOMA'],
            "CDIDIOM" => $parametros[0]['CDIDIOM']
        );
        $dados = $this->Sm00057001ConfiguracaoRegionalIdiomaFactory->validaConfiguracaoRegionalIdioma($paramsaux);
        try {
            foreach ($parametros as $chave => $linha) {
                if ($linha["CDIDIOM"] == 0) {
                    $CDIDIOM = $this->newCode->getCodeByTableName("IDIOMA", $NRORG, 1, 10, false);
                    if ($dados[0]["VALIDAIDIOMA"] > 0) {
                        throw new \Exception("IDIOMA JÁ EXISTE!");
                    } 
                    else{
                        $dataParam = array(
                            "CDIDIOM"        => $CDIDIOM,
                            "NMIDIOMA"       => $linha["NMIDIOMA"],
                            "NRORG"          => $NRORG,
                            "NRORGINCLUSAO"  => $NRORG,
                            "CDOPERINCLUSAO" => $cdoperador,
                            "IDATIVO"        => $linha["IDATIVO"],
                            "IDPADRAO"       => $linha["IDPADRAO"],
                        );
                        $this->Sm00057001ConfiguracaoRegionalIdiomaFactory->inserirConfiguracaoRegionalIdioma($dataParam);
                        if ($linha["IDPADRAO"] == "S") {
                            $dataParam = array(
                                "IDPADRAO" => "N",
                                "CDIDIOM"  => $CDIDIOM,
                            );
                            $this->Sm00057001ConfiguracaoRegionalIdiomaFactory->atualizarConfiguracaoRegionalIdPadraoIdioma($dataParam);
                        }
                    }
                } else{
                    if ($dados[0]["VALIDAIDIOMA"] > 0) {
                        throw new \Exception("IDIOMA JÁ EXISTE!");
                    } 
                    else {
                        $dataParam = array(
                            "NMIDIOMA"     => $linha["NMIDIOMA"],
                            "NRORG"        => $NRORG,
                            "NRORGULTATU"  => $NRORG,
                            "CDOPERULTATU" => $cdoperador,
                            "IDATIVO"      => $linha["IDATIVO"],
                            "IDPADRAO"     => $linha["IDPADRAO"],
                            "CDIDIOM"      => $linha["CDIDIOM"],
                        );
                        $this->Sm00057001ConfiguracaoRegionalIdiomaFactory->atualizarConfiguracaoRegionalIdioma($dataParam);

                        if ($linha["IDPADRAO"] == "S") {
                            $dataParam = array(
                                "IDPADRAO" => "N",
                                "CDIDIOM"  => $linha["CDIDIOM"],
                            );
                            $this->Sm00057001ConfiguracaoRegionalIdiomaFactory->atualizarConfiguracaoRegionalIdPadraoIdioma($dataParam);
                        }
                    }
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deletarConfiguracaoRegionalIdioma($parametros)
    {
        $this->connection->beginTransaction();
        try {
            foreach ($parametros as $linha) {
                $dataParam = array("CDIDIOM" => $linha["CDIDIOM"],);
                $this->Sm00057001ConfiguracaoRegionalIdiomaFactory->deletarConfiguracaoRegionalIdioma($dataParam);
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
